#include "pch.h"
#include "common.h"



CubeHeightmap *CubeHeightmap::working_chmap = NULL;



static DWORD _black_fn(float x,float y,float z)
{
	return 0;
}


static bool _sphere_bounds(float px,float py,float r,float &x1,float &x2)
{
	//	float a = py*py-r*r;
	//	float b = -2*px*py;
	//	float c = px*px-r*r;
	//	float d = b*b - 4*a*c;
	//	if(d<0) return false;
	//	x1 = (-b-sqrt(d))/(2*a);
	//	x2 = (-b+sqrt(d))/(2*a);


	//	()
	//	cls(0, 0, 0);
	//	xc = xres*0.735;
	//	yc = yres/2;
	//	ox = mousx-xc;
	//	oy = mousy-yc;
	//	r = 30;
	//	drawsph(ox+xc, oy+yc, -r);
	//	
	//	a = r*r/(ox*ox+oy*oy);
	//	b = sqrt(a-a*a);
	//	
	//	x1 = b*ox + a*oy;
	//	y1 = b*oy - a*ox;
	//	moveto(xc, yc); lineto(x1*100+xc, y1*100+yc);
	//	
	//	x2 = b*ox - a*oy;
	//	y2 = b*oy + a*ox;
	//	moveto(xc, yc); lineto(x2*100+xc, y2*100+yc);
	//	
	//	d = 50;
	//	u1=-1000; if( y2>0 ) u1 = x2/y2;
	//	u2= 1000; if( y1>0 ) u2 = x1/y1;
	//	moveto(xc+u1*d, yc+d); lineto(xc+u2*d, yc+d);

	
	x1=-1000;
	x2= 1000;
	float a = r*r/(px*px+py*py);
	float b = a-a*a;
	if(b<0) return true;
	b = sqrt(b);

	float _x1 = b*px + a*py;
	float _y1 = b*py - a*px;
	float _x2 = b*px - a*py;
	float _y2 = b*py + a*px;
	if( _y2>0 ) x1 = _x2/_y2;
	if( _y1>0 ) x2 = _x1/_y1;

	return true;
}



void CubeHeightmap::PosToTexel(vec3 dir,int &f,int &u,int &v)
{
    const float dirX_abs = fabs(dir.x);
    const float dirY_abs = fabs(dir.y);
    const float dirZ_abs = fabs(dir.z);
	if(dirX_abs>dirY_abs)
		if(dirX_abs>dirZ_abs)	f = 0;
		else					f = 4;
	else
		if(dirY_abs>dirZ_abs)	f = 2;
		else					f = 4;

	float w = ((float*)&dir)[f/2];
	if(w<0)
	{
		f++;
		w = -w;
	}
	dir *= 1.f/w;

	float uf, vf;
	switch(f)
	{
		case 0: uf=-dir.z; vf=-dir.y; break;
		case 1: uf= dir.z; vf=-dir.y; break;
		case 2: uf= dir.x; vf= dir.z; break;
		case 3: uf= dir.x; vf=-dir.z; break;
		case 4: uf= dir.x; vf=-dir.y; break;
		case 5: uf=-dir.x; vf=-dir.y; break;
	}
	uf = (uf+1.f)/2.f*HEIGHTMAP_SIZE_F;
	if(uf<0.5f) uf = 0.5f;
	if(uf>HEIGHTMAP_SIZE_F-0.5f) uf = HEIGHTMAP_SIZE_F-0.5f;
	vf = (vf+1.f)/2.f*HEIGHTMAP_SIZE_F;
	if(vf<0.5f) vf = 0.5f;
	if(vf>HEIGHTMAP_SIZE_F-0.5f) vf = HEIGHTMAP_SIZE_F-0.5f;
	u = int(uf);
	v = int(vf);
}


vec3 CubeHeightmap::TexelToPos(int face,int iu,int iv)
{
	float u = (iu+0.5f)/HEIGHTMAP_SIZE_F*2.f-1.f;
	float v = (iv+0.5f)/HEIGHTMAP_SIZE_F*2.f-1.f;
	switch(face)
	{
		case 0: return vec3( 1,-v,-u);
		case 1: return vec3(-1,-v, u);
		case 2: return vec3( u, 1, v);
		case 3: return vec3( u,-1,-v);
		case 4: return vec3( u,-v, 1);
		case 5: return vec3(-u,-v,-1);
	}
	return vec3(0,0,0);
}

void CubeHeightmap::Clear()
{
	for(int f=0;f<6;f++)
	{
		for(int v=0;v<HEIGHTMAP_SIZE;v++)
			for(int u=0;u<HEIGHTMAP_SIZE;u++)
			{
				height[f][v][u] = 1.f;
				normal[f][v][u] = vec3(0,0,0);
			}

		is_dirty[f] = true;
		dirty_rect[f].left = 0;
		dirty_rect[f].top = 0;
		dirty_rect[f].right = HEIGHTMAP_SIZE;
		dirty_rect[f].bottom = HEIGHTMAP_SIZE;
	}

	if(cube_texture) cube_texture->Release();
	if(height_texture) height_texture->Release();
	cube_texture = NULL;
	height_texture = NULL;
}

void CubeHeightmap::Load(const char *path)
{
	Clear();
	UpdateTexture();

	vector<byte> data;
	if(!NFS.GetFileBytes(path,data)) return;
	if(data.size() != HEIGHTMAP_SIZE*HEIGHTMAP_SIZE*6*2 + 12) return;
	if(*(int*)&data[0]!='PMHC') return;
	if(*(int*)&data[4]!=HEIGHTMAP_SIZE) return;

	unsigned short *d = (unsigned short*)&data[8];
	for(int f=0;f<6;f++)
	{
		for(int v=0;v<HEIGHTMAP_SIZE;v++)
			for(int u=0;u<HEIGHTMAP_SIZE;u++)
			{
				height[f][v][u] = *d++ / 65535.f;
				normal[f][v][u] = vec3(0,0,0);
			}

		is_dirty[f] = true;
		dirty_rect[f].left = 0;
		dirty_rect[f].top = 0;
		dirty_rect[f].right = HEIGHTMAP_SIZE;
		dirty_rect[f].bottom = HEIGHTMAP_SIZE;
	}

	UpdateTexture();
}

void CubeHeightmap::Save(const char *path)
{
	FILE *fp = fopen(path,"wb");
	if(!fp) return;
	int id;
	id = 'PMHC';			fwrite(&id,1,4,fp);
	id = HEIGHTMAP_SIZE;	fwrite(&id,1,4,fp);

	Quantize();
	UpdateTexture();

	for(int f=0;f<6;f++)
		for(int v=0;v<HEIGHTMAP_SIZE;v++)
			for(int u=0;u<HEIGHTMAP_SIZE;u++)
			{
				id = int(floor(height[f][v][u]*65535.f+0.5f));
				fwrite(&id,1,2,fp);
			}

	id = 0;
	fwrite(&id,1,4,fp);
	fclose(fp);
}


void CubeHeightmap::Quantize()
{
	for(int f=0;f<6;f++)
	{
		for(int v=0;v<HEIGHTMAP_SIZE;v++)
			for(int u=0;u<HEIGHTMAP_SIZE;u++)
			{
				height[f][v][u] = floor(height[f][v][u]*65535+0.5f)/65535;
				normal[f][v][u] = vec3(0,0,0);
			}

		is_dirty[f] = true;
		dirty_rect[f].left = 0;
		dirty_rect[f].top = 0;
		dirty_rect[f].right = HEIGHTMAP_SIZE;
		dirty_rect[f].bottom = HEIGHTMAP_SIZE;
	}
}

void CubeHeightmap::Draw(vec3 draw_dir,float radius,float h,float power)
{
	draw_dir.normalize();
	radius *= 5;
	power *= power;
	power *= power;
	power *= power;
	power *= power;
	for(int f=0;f<6;f++)
	{
		vec3 dir(0, 0, 0), udir(0, 0, 0), vdir(0, 0, 0);
		switch( f )
		{
		case 0: dir.x= 1; udir.z=-1; vdir.y=-1; break;
		case 1: dir.x=-1; udir.z= 1; vdir.y=-1; break;
		case 2: dir.y= 1; udir.x= 1; vdir.z= 1; break;
		case 3: dir.y=-1; udir.x= 1; vdir.z=-1; break;
		case 4: dir.z= 1; udir.x= 1; vdir.y=-1; break;
		case 5: dir.z=-1; udir.x=-1; vdir.y=-1; break;
		}

		if( draw_dir.dot(dir)<0 )
			continue;

		float u1, u2, v1, v2;
		if( !_sphere_bounds(draw_dir.dot(udir), draw_dir.dot(dir), radius, u1, u2) ) u1=-1, u2=1;
		if( !_sphere_bounds(draw_dir.dot(vdir), draw_dir.dot(dir), radius, v1, v2) ) v1=-1, v2=1;

		u1 = (u1+1)/2*HEIGHTMAP_SIZE;
		if( u1<0.5f ) u1 = 0.5f;
		if( u1>HEIGHTMAP_SIZE-0.5f ) u1 = HEIGHTMAP_SIZE-0.5f;
		u2 = (u2+1)/2*HEIGHTMAP_SIZE;
		if( u2<0.5f ) u1 = 0.5f;
		if( u2>HEIGHTMAP_SIZE-0.5f ) u2 = HEIGHTMAP_SIZE-0.5f;

		v1 = (v1+1)/2*HEIGHTMAP_SIZE;
		if( v1<0.5f ) v1 = 0.5f;
		if( v1>HEIGHTMAP_SIZE-0.5f ) v1 = HEIGHTMAP_SIZE-0.5f;
		v2 = (v2+1)/2*HEIGHTMAP_SIZE;
		if( v2<0.5f ) v2 = 0.5f;
		if( v2>HEIGHTMAP_SIZE-0.5f ) v2 = HEIGHTMAP_SIZE-0.5f;

		if( u1>=u2 || v1>=v2 )
			continue;

		for( int v=int(v1); v<=int(v2); v++ )
		{
			bool ut = false;
			int umin, umax;
			for( int u=int(u1); u<=int(u2); u++ )
			{
				vec3 p = TexelToPos(f,u,v).get_normalized();
				float a = 1-(draw_dir-p).length()/radius;
				if(a<0) a = 0;
				//float a = 1-p.dot(draw_dir);
				//if(a>=radius+0.02f)
				//	continue;
				//a /= radius;
				//if(a>1) a = 1;
				//a = 1-a;
				//a *= a*(3-2*a);
				a *= a*a*(a*(a*6-15)+10);
				
				a = 1-pow(1-a,power);

				if(!ut) umin = u, ut = true;
				umax = u+1;

				height[f][v][u] +=
					(h - height[f][v][u])*a;
				normal[f][v][u] = vec3(0,0,0);
			}

			if(ut)
				AddDirtyRegion(f,umin,v,umax,v+1);
		}
	}
}


void CubeHeightmap::UpdateTexture()
{
	if(cube_texture==NULL || height_texture==NULL)
	{
		if(cube_texture) cube_texture->Release();
		if(height_texture) height_texture->Release();
		cube_texture = NULL;
		height_texture = NULL;

		Dev->CreateCubeTexture(HEIGHTMAP_SIZE,1,0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED,&cube_texture,NULL);
		Dev->CreateCubeTexture(HEIGHTMAP_SIZE,1,0,D3DFMT_L8,D3DPOOL_MANAGED,&height_texture,NULL);

		for(int f=0;f<6;f++)
		{
			is_dirty[f] = true;
			dirty_rect[f].left = 0;
			dirty_rect[f].top = 0;
			dirty_rect[f].right = HEIGHTMAP_SIZE;
			dirty_rect[f].bottom = HEIGHTMAP_SIZE;
		}
	}

	if(cube_texture==NULL || height_texture==NULL)
		return;

	UpdateNormals();

	IDirect3DCubeTexture9 *ctex = cube_texture;
	IDirect3DCubeTexture9 *htex = height_texture;

	D3DLOCKED_RECT lr_c;
	D3DLOCKED_RECT lr_h;
	int face;
	float /*u,v,*/dt;
//	float x,y,z,l;

	dt = 2.f/float(HEIGHTMAP_SIZE);

	bool changed = false;
	for(face=0;face<6;face++)
	{
		if(!is_dirty[face])
			continue;

		if(FAILED(ctex->LockRect((D3DCUBEMAP_FACES)face,0,&lr_c,&dirty_rect[face],0)))
			break;

		for(int v=dirty_rect[face].top;v<dirty_rect[face].bottom;v++)
		{
			DWORD *cdata = (DWORD*)((char*)lr_c.pBits + lr_c.Pitch*(v-dirty_rect[face].top));

			for(int u=dirty_rect[face].left;u<dirty_rect[face].right;u++)
				*cdata++ = (normal[face][v][u]*0.5f+vec3(0.5f,0.5f,0.5f)).make_rgba(height[face][v][u]);
		}

		ctex->UnlockRect((D3DCUBEMAP_FACES)face,0);


		if(FAILED(htex->LockRect((D3DCUBEMAP_FACES)face,0,&lr_h,&dirty_rect[face],0)))
			break;

		for(int v=dirty_rect[face].top;v<dirty_rect[face].bottom;v++)
		{
			BYTE  *hdata = (BYTE *)((char*)lr_h.pBits + lr_h.Pitch*(v-dirty_rect[face].top));

			for(int u=dirty_rect[face].left;u<dirty_rect[face].right;u++)
				*hdata++ = int(floor(height[face][v][u]*255+0.5f));;
		}

		htex->UnlockRect((D3DCUBEMAP_FACES)face,0);

		is_dirty[face] = false;
		changed = true;
	}

	if( changed )
		ctex->GenerateMipSubLevels();
}

bool CubeHeightmap::FindNearestPoint(const vec3 &pos,float r,vec3 &pt, float r_offs)
{
	float ph = pos.length();
	bool found = false;
	float r2 = r*r;

	for(int f=0;f<6;f++)
	{
		vec3 dir(0,0,0), udir(0,0,0), vdir(0,0,0);
		switch(f)
		{
			case 0: dir.x= 1; udir.z=-1; vdir.y=-1; break;
			case 1: dir.x=-1; udir.z= 1; vdir.y=-1; break;
			case 2: dir.y= 1; udir.x= 1; vdir.z= 1; break;
			case 3: dir.y=-1; udir.x= 1; vdir.z=-1; break;
			case 4: dir.z= 1; udir.x= 1; vdir.y=-1; break;
			case 5: dir.z=-1; udir.x=-1; vdir.y=-1; break;
		}

		if(pos.dot(dir)<0)
			continue;

		float u1, u2, v1, v2;
		if(!_sphere_bounds(pos.dot(udir),pos.dot(dir),r,u1,u2)) continue;
		if(!_sphere_bounds(pos.dot(vdir),pos.dot(dir),r,v1,v2)) continue;

		u1 = (u1+1)/2*HEIGHTMAP_SIZE;
		if(u1<0.5f) u1 = 0.5f;
		if(u1>HEIGHTMAP_SIZE-0.5f) u1 = HEIGHTMAP_SIZE-0.5f;
		u2 = (u2+1)/2*HEIGHTMAP_SIZE;
		if(u2<0.5f) u1 = 0.5f;
		if(u2>HEIGHTMAP_SIZE-0.5f) u2 = HEIGHTMAP_SIZE-0.5f;

		v1 = (v1+1)/2*HEIGHTMAP_SIZE;
		if(v1<0.5f) v1 = 0.5f;
		if(v1>HEIGHTMAP_SIZE-0.5f) v1 = HEIGHTMAP_SIZE-0.5f;
		v2 = (v2+1)/2*HEIGHTMAP_SIZE;
		if(v2<0.5f) v2 = 0.5f;
		if(v2>HEIGHTMAP_SIZE-0.5f) v2 = HEIGHTMAP_SIZE-0.5f;

		if(u1>=u2 || v1>=v2)
			continue;

		for(int v=int(v1);v<=int(v2);v++)
			for(int u=int(u1);u<=int(u2);u++)
			{
				float h = height[f][v][u];
				if(h<0.72f) h = 0.45f;
				h += r_offs;
				if(h>ph) h = ph;
				vec3 p = TexelToPos(f,u,v).get_normalized()*h - pos;
				float d = p.dot(p);
				if(d<r2)
				{
					pt = p + pos;
					r2 = d;
					found = true;
				}
			}
	}

	return found;
}

void CubeHeightmap::UpdateNormals()
{
	for(int f=0;f<6;f++)
	{
		if(!is_dirty[f])
			continue;

		vec3 t0, b0;
		if(f==0 || f==1) t0=vec3(0,1,0), b0=vec3(0,0,1);	// X
		if(f==2 || f==3) t0=vec3(1,0,0), b0=vec3(0,0,1);	// Y
		if(f==4 || f==5) t0=vec3(1,0,0), b0=vec3(0,1,0);	// Z

		for(int v=dirty_rect[f].top;v<dirty_rect[f].bottom;v++)
			for(int u=dirty_rect[f].left;u<dirty_rect[f].right;u++)
			{
				vec3 *n = &normal[f][v][u];
                vec3 n_copy = *n;
				if(n_copy.x || n_copy.y || n_copy.z)
					continue;

				vec3 dir = TexelToPos(f,u,v);
				vec3 d0 = dir;
				dir.normalize();

				vec3 t, b;
				float h = height[f][v][u];
				vec3 p = dir*h;
				float e = 2.0f/HEIGHTMAP_SIZE;

				int f1, u1, v1;

				PosToTexel(d0+t0*e,f1,u1,v1);
				t = d0+t0*e;
                t.normalize();
                t *= height[f1][v1][u1];
                t -= p;

				PosToTexel(d0+b0*e,f1,u1,v1);
				b = d0+b0*e;
                b.normalize();
                b *= height[f1][v1][u1];
                b -= p;

				n_copy = t.cross(b);
				if(n_copy.dot(p)<0)
                    n_copy = -n_copy;
				n_copy.normalize();
                *n = n_copy;
			}
	}
}

void CubeHeightmap::AddDirtyRegion(int f,int x1,int y1,int x2,int y2)
{
	if(x1<0) x1 = 0;
	if(x2>HEIGHTMAP_SIZE) x2 = HEIGHTMAP_SIZE;
	if(y1<0) y1 = 0;
	if(y2>HEIGHTMAP_SIZE) y2 = HEIGHTMAP_SIZE;

	if(!is_dirty[f])
	{
		is_dirty[f] = true;
		dirty_rect[f].left	 = x1;
		dirty_rect[f].right	 = x2;
		dirty_rect[f].top	 = y1;
		dirty_rect[f].bottom = y2;
	}
	else
	{
		dirty_rect[f].left	 = min(dirty_rect[f].left,x1);
		dirty_rect[f].right	 = max(dirty_rect[f].right,x2);
		dirty_rect[f].top	 = min(dirty_rect[f].top,y1);
		dirty_rect[f].bottom = max(dirty_rect[f].bottom,y2);
	}
}

void CubeHeightmap::ExportToMesh(const char *path)
{
	vector<vec3> vb;
	vector<int> ib;

	for(int f=0;f<6;f++)
		for(int y=0;y<HEIGHTMAP_SIZE;y++)
			for(int x=0;x<HEIGHTMAP_SIZE;x++)
			{
				vb.push_back( TexelToPos(f,x,y).get_normalized()*height[f][y][x] );
				vb.push_back( normal[f][y][x] );
			}

	for(int f=0;f<6;f++)
		for(int y=0;y<HEIGHTMAP_SIZE-1;y++)
			for(int x=0;x<HEIGHTMAP_SIZE-1;x++)
			{
				int a = x + y*HEIGHTMAP_SIZE + f*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE;
				int b = a + 1;
				int c = a + HEIGHTMAP_SIZE;
				int d = c + 1;
				ib.push_back(a);
				ib.push_back(b);
				ib.push_back(c);
				ib.push_back(c);
				ib.push_back(b);
				ib.push_back(d);
			}

	const char *ADJ[6] = {
		"2db5ac3db4db",
		"2ac4ac3ac5db",
		"5ba0ba4ba1ba",
		"4cd0cd5cd1cd",
		"2cd0ac3ba1db",
		"2ba1ac3cd0db"
	};
	int pos[4] = {
		0,
		HEIGHTMAP_SIZE-1,
		(HEIGHTMAP_SIZE-1)*HEIGHTMAP_SIZE,
		(HEIGHTMAP_SIZE-1)*HEIGHTMAP_SIZE + (HEIGHTMAP_SIZE-1)
	};

	for(int f=0;f<6;f++)
		for(int s=0;s<4;s++)
		{
			int n = ADJ[f][s*3]-'0';
			if(n<f) continue;

			int a  = f*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos["abdc"[s]-'a'];
			int da = f*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos["bdca"[s]-'a'];
			int b  = n*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos[ADJ[f][s*3+1]-'a'];
			int db = n*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos[ADJ[f][s*3+2]-'a'];
			da -= a;
			da /= HEIGHTMAP_SIZE-1;
			db -= b;
			db /= HEIGHTMAP_SIZE-1;

			for(int i=0;i<HEIGHTMAP_SIZE-1;i++)
			{
				ib.push_back(a);
				ib.push_back(b);
				ib.push_back(a+da);
				ib.push_back(a+da);
				ib.push_back(b);
				ib.push_back(b+db);
				a += da;
				b += db;
			}

			int m = ADJ[f][((s+1)%4)*3]-'0';
			if(m<f) continue;
			int v1 = f*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos["bdca"[s]-'a'];
			int v2 = n*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos[ADJ[f][s*3+2]-'a'];
			int v3 = m*HEIGHTMAP_SIZE*HEIGHTMAP_SIZE + pos[ADJ[f][((s+1)%4)*3+1]-'a'];
			ib.push_back(v1);
			ib.push_back(v2);
			ib.push_back(v3);
		}

	DevMesh mesh;
	if(!mesh.LoadVBIB(&vb[0],vb.size()/2,sizeof(vec3)*2,D3DFVF_XYZ|D3DFVF_NORMAL,
				  &ib[0],ib.size(),false))
	{
		MessageBox(0,"Mesh creation failed!","!",0);
		return;
	}
	if(!mesh.Simplify(10000,true))
	{
		MessageBox(0,"Mesh simplification failed!","!",0);
		return;
	}
	if(!mesh.Optimize())
	{
		MessageBox(0,"Mesh optimization failed!","!",0);
		return;
	}

	D3DXSaveMeshToX(path,mesh.mesh,NULL,NULL,NULL,0,D3DXF_FILEFORMAT_TEXT);
}
