
#pragma once



#define HEIGHTMAP_SIZE		256
#define HEIGHTMAP_SIZE_F	256.f

class CubeHeightmap {
public:

	CubeHeightmap() { cube_texture=NULL; height_texture=NULL; Clear(); }
	~CubeHeightmap() { Clear(); }


	void PosToTexel(vec3 dir, int &f, int &u, int &v);
	vec3 TexelToPos(int face, int iu, int iv);

	void Clear();
	void Load(const char *path);
	void Save(const char *path);
	void Quantize();
	void Draw(vec3 dir, float radius, float h, float power=1.f);
	void UpdateTexture();

	bool FindNearestPoint(const vec3 &pos, float r, vec3 &pt, float r_offs=0.f);

	IDirect3DCubeTexture9 *GetMainTexture() { return cube_texture; }
	IDirect3DCubeTexture9 *GetHeightTexture() { return height_texture; }

	void ExportToMesh(const char *path);


private:
	float					height[6][HEIGHTMAP_SIZE][HEIGHTMAP_SIZE];
	vec3					normal[6][HEIGHTMAP_SIZE][HEIGHTMAP_SIZE];
	bool					is_dirty[6];
	RECT					dirty_rect[6];
	IDirect3DCubeTexture9	*cube_texture;
	IDirect3DCubeTexture9	*height_texture;

	static CubeHeightmap *working_chmap;

	void UpdateNormals();
	void AddDirtyRegion(int f, int x1, int y1, int x2, int y2);

};
