#include "pch.h"
#include "common.h"

void GetConfigString(string& outValue, const char* sectionName, const char* keyName, const char* defaultValue)
{
    char sz[MAX_PATH];
    GetCurrentDirectory(_countof(sz), sz);

    string filePath = sz;
    if(!filePath.empty() && filePath.back() != '\\' && filePath.back() != '/')
    {
        filePath += '\\';
    }

    filePath += "Config.ini";
    GetPrivateProfileString(sectionName, keyName, defaultValue, sz, _countof(sz), filePath.c_str());
    assert(errno != 2);

    outValue = sz;
}

int GetConfigInt(const char* sectionName, const char* keyName, const char* defaultValue)
{
    string s;
    GetConfigString(s, sectionName, keyName, defaultValue);
    return atoi(s.c_str());
}
