#include "pch.h"
#include "common.h"





void EngineMesh::LoadPly(const char *path)
{
	vb.clear();
	ib.clear();

	vector<string> lines;
	if( !NFS.GetFileLines(path, lines) )
		return;

	bool header = true;
	int nv=0, nf=0;

	for( int i=0; i<lines.size(); i++ )
	{
		const char *s = lines[i].c_str();

		if( header )
		{
			string c0 = ParseString(s);
			string c1 = ParseString(s);
			if( c0=="end_header" ) header=false;
			if( c0=="element" )
			{
				if( c1=="vertex" ) nv=ParseInt(s);
				if( c1=="face" ) nf=ParseInt(s);
			}
		}
		else if( vb.size()<nv )
		{
			Vertex v;
			v.pos.x = ParseFloat(s);
			v.pos.y = ParseFloat(s);
			v.pos.z = ParseFloat(s);
			v.normal.x = ParseFloat(s);
			v.normal.y = ParseFloat(s);
			v.normal.z = ParseFloat(s);
			ParseFloat(s);
			ParseFloat(s);
			//v.c0  = ParseInt(s)<<16;
			//v.c0 |= ParseInt(s)<< 8;
			//v.c0 |= ParseInt(s);
			vb.push_back(v);
		}
		else if( nf>0 )
		{
			int fv = ParseInt(s);
			int v0 = ParseInt(s);
			int v1 = ParseInt(s);
			while( fv>2 )
			{
				int v2 = ParseInt(s);
				ib.push_back(v0);
				ib.push_back(v1);
				ib.push_back(v2);
				v1 = v2;
				fv--;
			}
			nf--;
		}
	}
}
