const BUG_SHOT_INTERVAL = 0.1;

class BugSmall extends Object {

	bug_speed = 0.2;
	last_shot_time  = 0;
	

	constructor(new_pos, bug_size=0.025) {
		base.constructor();

		size = vec2(bug_size,bug_size);
		
		physics_mode = 1;
		physics_gravity = 1.0;//GRAVITY;
		physics_radius = bug_size;
		physics_sink = bug_size;//*0.85;
		render_layers = 5;
		render_thickness = bug_size*0.3;
		

		hit_faction = FACTION_ENEMY;

		pos = normalize(new_pos);
		front = vec3(frand_s(),frand_s(),frand_s());

		push_data();

		//SetStaticFrame("crossair_whiteOutline.png")
		SetAnimation("BugWalking")
	}

	function logic_update()
	{
		local t = eng.GetElapsedTime();
		if( wall_collision )
		{
			wall_collision = 0;
			front = -front;

			if( length(pos)<0.72 )
				remove();
		}
			
		if(t >= last_shot_time + BUG_SHOT_INTERVAL)
		{
			bugshoot();
			last_shot_time = t;
		}
		
		if( eng.FindClosestFaction(pos.x, pos.y, pos.z, 0.2, FACTION_HOMEBASE) )
		{
			local delta = other.pos - pos;
			local dist = length(delta);
			if( dist > 0.05 )
				front = -normalize(delta);
			vel = normalize(front)*bug_speed;
		}
		else if( eng.FindClosestFaction(pos.x, pos.y, pos.z, 0.5, FACTION_PLAYER) )
		{
			local delta = other.pos - pos;
			local dist = length(delta);
			if( dist > 0.05 )
				front = normalize(delta);
			front += right*frand_s();
			vel = normalize(front)*bug_speed;
		}
		else
		{
			front += right*frand_s();
			vel = normalize(front)*bug_speed;
		}


		update_time += 0.25 + frand_s()*0.02;	// Next update in 0.25
	}


	function bugshoot()
	{
		//print("Pif paf!\n");
		eng.PlaySoundEffect("Laser", 1.0);
		EnemyShot(pos + (front + right*0.06) * (length(size) * 1.01), front, vec2(0.002, 0.015),0.01);
	}


}

class BugBig extends BugSmall {

	constructor(new_pos) {
		base.constructor(new_pos,0.05);
		render_layers = 15;
		bug_speed = 0.125;
	}

	function bugshoot()
	{
		//print("Pif paf!\n");
		eng.PlaySoundEffect("Laser", 1.0);
		EnemyShot(pos + (front + right*0.06) * (length(size) * 1.01), front, vec2(0.004, 0.020),0.07);
	}
}

