
const GRAVITY = 4.0;

const FACTION_PLAYER			= 0x01;
const FACTION_ENEMY				= 0x02;
const FACTION_HOMEBASE			= 0x04;
const FACTION_PICKUP			= 0x08;





objects <- []		// All objects. Linking to engine keeps only weak reference.



class Object extends EngineObject {

	pos		= vec3(0,0,1);
	front	= vec3(0,1,0);
	vel		= vec3(0,0,0);
	size	= vec2(0.05,0.05);		// push only

	right   = vec3(0,0,0);				// read only, computed by pull_data()


	constructor() {
		base.constructor();
		objects.push(this);
		eng.LinkObject(this);
	}

	function remove() {
		eng.UnlinkObject(this);

		local idx = objects.find(this);
		if( idx!=null )
			objects.remove(idx);
	}

	function pull_data() {
		pos   = vec3( GetPositionX(), GetPositionY(), GetPositionZ() );
		front = vec3( GetFrontX(), GetFrontY(), GetFrontZ() );
		vel   = vec3( GetVelocityX(), GetVelocityY(), GetVelocityZ() );
		
		right = normalize(cross(front,pos));
	}

	function push_data() {
		SetPosition(pos.x,pos.y,pos.z);
		SetFront(front.x,front.y,front.z);
		SetVelocity(vel.x,vel.y,vel.z);
		SetSize(size.x,size.y);
	}

	function update()
	{
		pull_data();

		logic_update();

		push_data();
	}

	function logic_update() { update_time = 1; }		// override this
	function hit_target(other) { }						// override this
}
