
class PickupObject extends Object {

	function on_pickup(player) { }		// "abstract"
}

class Crystal extends PickupObject {

	spawn_time = 0;


	constructor(new_pos, id) {
		base.constructor()

		pos = new_pos;
		
		render_attach = id;

		random_spawn();
	}

	function random_spawn()
	{
		pos = vec3(frand_s(),frand_s(),-1);

		try_spawn();
	}

	function try_spawn()
	{
		pos = normalize(pos)*1.1;

		physics_mode = 1;
		physics_radius = 0.015;		// hardcoded in shader
		physics_sink = 0;
		physics_gravity = 1.0;

		render_mode = 0;
		hit_faction = 0;

		spawn_time = 1;

		push_data()
		SetVelocityForce(0,0,0);
	}

	function logic_update()
	{
		if( physics_mode )
		{
			if( length(pos)>0.75 && length(pos)<0.9 && length(vel)<0.01 )
			{
				render_mode = 3;
				physics_mode = 0;
				physics_gravity = 0;
				hit_faction = FACTION_PICKUP;
				vel = vec3(0,0,0);
				return;
			}
			vel = vec3(0,0,0);
			
			spawn_time -= time_delta;
			if( spawn_time < 0 )
				random_spawn();
			return;
		}
	}

	function on_pickup(player)
	{
		random_spawn();
	}
}
