const SHOT_DURATION = 2.0;

class Shot extends Object {
	die_time = 0;

	constructor(new_pos, new_front) {
		base.constructor();
		front = new_front;
		vel = normalize(front)*2.0;
		size = vec2(0.005, 0.025)*1.5;
		pos = new_pos;
		level_min = level_max = length(pos);

		physics_mode = 2;
		physics_radius = physics_sink = 0.015;

		SetStaticFrame("laserRed01.png");
		push_data();

		hit_colmask = FACTION_ENEMY;


		die_time = eng.GetElapsedTime() + SHOT_DURATION;
	}

	function logic_update() {
		local t = eng.GetElapsedTime();
		if(t >= die_time || wall_collision ) {
			remove();
		}

		local pp = normalize(pos);
		vel -= pp*dot(pp,vel);
		vel = normalize(vel)*2.0;

		update_time = 0.2;
	}

	function hit_target(other)
	{
		other.remove();
		remove();
	}
}

class EnemyShot extends Shot {
		damage = 0.1;
	constructor(new_pos, new_front, shootsize, dmg) {
		base.constructor(new_pos, new_front);
		//size = vec2(0.002, 0.015)
		size = shootsize
		damage = dmg;
		SetStaticFrame("laserGreen03.png");

		hit_colmask = FACTION_PLAYER | FACTION_ENEMY;

	}
	
	function hit_target(other)
	{
		if (other.hit_faction != FACTION_PLAYER) 
		{
			remove();
			return;
		}
		other.energy -= damage;
		remove();
	}
}

