#ifdef EXTENDED_SHADER_FEATURES
float4 PS_Raytrace_Full(float2 vpos : vpos, out float4 heat : color1, out float depth_out : DEPTH) : color0
#else
float4 PS_Raytrace_Limited(float2 vpos : vpos, out float4 heat : color1) : color0
#endif
{
	vpos = (vpos+.5-vppos-vpsize/2)/(vpsize.y*vzoom);
	heat = 0;
#ifdef EXTENDED_SHADER_FEATURES
	depth_out = 1;
#endif
	
	float3 cpos = float3(0,0,-2);
	float3 rdir = normalize(float3(vpos,1));
	float3 ldir = normalize(float3(-1,-1,-1));
	float3 mrp1 = ball1_pos;
	float3 mrp2 = ball2_pos;
	cpos = M(cpos);
	rdir = M(rdir);
	ldir = M(ldir);
	
	float2 mr1 = trace_marble(cpos - mrp1,rdir);
	float2 mr2 = trace_marble(cpos - mrp2,rdir);
//	float2 mr2h = sphere(cpos - mrp2,rdir,0.1);
	if(mr1.x<=0) mr1.x = 1e9;
	if(mr2.x<=0) mr2.x = 1e9;
	
	float4 hm;
	float3 p, n;
	float2 s1 = trace_moon(cpos,rdir,/*min(mr1.x,mr2.x)*/1e9,hm,p);
	float4 ds = 0;
	heat = mystep(m_mist_params.y*m_mist_params.y,m_mist_params.x*m_mist_params.x,s1.y);

	if(s1.x<=0) s1.x = 1e9;
	else		s1.x = dot(p-cpos,rdir);
	float sd = min(s1.x,min(mr1.x,mr2.x));
	float3 sp = cpos + rdir*sd;
	
/*	if(mr2h.x>0)
	{
		mr2h.y = min(mr2h.y,sd);
		heat += saturate((mr2h.y-mr2h.x)*5);
	}
*/
	if(sd>=1e9)
		return 0;

	float ms0 = trace_moon_shadow(sp,ldir);
	float4 ms1 = trace_marble_shadow(sp-mrp1,ldir,ball1_color);
	float4 ms2 = trace_marble_shadow(sp-mrp2,ldir,ball2_color);
	float mse = mystep(0.725*0.725,0.705*0.705,dot(sp,sp));
	float4 trans = 1;
	
	if(mr1.x==sd)		ds = shade_marble(cpos - mrp1,rdir,ldir,mr1,ball1_color,trans,trans)*lerp(ms0*ms2,1,mse);
	else if(mr2.x==sd)	ds = shade_marble(cpos - mrp2,rdir,ldir,mr2,ball2_color,trans,trans)*lerp(ms0*ms1,1,mse);
	if(s1.x<1e9)
	{
		float4 md = shade_moon(cpos,rdir,ldir,hm,p,(s1.x==sd ? lerp(ms0*ms1*ms2,1,mse) : 1))*trans;
		ds += md;

		float zz = dot(p-cpos,dir_front);
#ifdef EXTENDED_SHADER_FEATURES
		depth_out = (zz-near_plane)/zz;
#endif
	}

	return ds;
}
