
#pragma once


class GameUI {
public:
	struct Message {
		string	text;
		int		width;
	};

	DevFont			font;
	RECT			msg_rect;
	string			message;
	bool			is_message;
	bool			show_game;
	vector<Message>	msg_queue;

	void Init();
	void Render();
	void DrawTextBox(const char *text, const RECT &box, int frame);
	void Tick(float delta);

	void PopMessage(const char *text, int width);
	void ClearMessages() { is_message=false; msg_queue.clear(); }
	bool IsActive() { return is_message; }
	bool IsShowGame() { return show_game; }
};

class GameUI2 {
public:
    GameUI2();
    void Init();
    ~GameUI2();
    void Update();
    void Render();

private:
    vec4 m_BarTexCoords = vec4(0.f, 0.f, 0.f, 0.f);

    void RenderCamera(size_t cameraIndex);
    void RenderBar(const vec2& leftTop, float percent);
};

extern GameUI2* g_GameUi;
